#ifndef _LEXER_H_
 #define _LEXER_H_
#include <stdlib.h>

typedef unsigned char uchar;

typedef enum {
    CH_LETTER = 0x01, CH_DIGIT = 0x02, CH_SEPARAT = 0x04,
    CH_SYMBOL = 0x08, CH_QUOTE = 0x10,
    CH_UNKNOWN= 0x7E, CH_FINAL = 0x7F
} hqCharType;

typedef enum {
    TOK_ERROR, TOK_NONE, TOK_FINAL, TOK_INT, TOK_FLOAT, TOK_SYMBOL,
    TOK_NAME, TOK_STRING
} hqTokenType;

typedef struct {
    char Sym[4];
    char Len;
    char Index;
    char More;
} SymbolRec;

class CLexer{
    // input params
public:
    char       *SS;
    hqCharType *CharTypeTable;
    SymbolRec **SymTable;
    int		cssn;	// Comment Start Symbol Number. -1 if none
    char       *ComEnd;	// End of comment
    // output params
    char       *Name;
    int		NameLen;
    double	ExtValue;
    int		IntValue;
    hqTokenType PrevTokenType;
    hqCharType	CharType;
    int		NoIntegers;
	int SetParseString( char *str );
	hqTokenType GetNextToken();
	~CLexer(){//free(SS);
	};
	char* GetCurrentPos();
};

/* Misc */

void UpcaseWin1251Str( char *Str );
void InitCharTypeTable( hqCharType *CharTypeTable, int CharTypes );

void TypeTableAddChars( hqCharType *CharTypeTable, char *Symbols,
			hqCharType CharType );

void PrepareSymTable( SymbolRec **SymTable, char *symbols );

//int IsEngWin1251RusName( char *Str );

extern char const Win1251UpcaseTbl[];


#endif //_LEXER_H_